#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-
# generated by wxGlade 0.6 on Sun Nov 25 17:19:29 2007
from __future__ import division

import wx

import matplotlib
if matplotlib.get_backend() != 'WXAgg':
    matplotlib.use('WXAgg')

from matplotlib.figure import Figure
from matplotlib.widgets import SpanSelector

from matplotlib.backends.backend_wxagg import FigureCanvasWxAgg as FigureCanvas
#from matplotlib.backends.backend_wx import NavigationToolbar2Wx as NavBar
from fitting.fitgui import NavBar,WheelZoomer

from spylot import Spectrum,SpectrumDrawingSettings,PhotometricBand
from fitting.fitgui import FitDialog

# begin wxGlade: extracode
# end wxGlade

class BandChoiceDialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        # begin wxGlade: BandChoiceDialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.photoComboBox = wx.ComboBox(self, -1, choices=["UBVRI", "ugriz", "u'g'r'i'z'"], style=wx.CB_DROPDOWN)
        self.clearCheckbox = wx.CheckBox(self, -1, "Clear Existing Bands?")
        self.okButton_copy = wx.Button(self, wx.ID_OK, "Ok")
        self.cancelButton_copy = wx.Button(self, wx.ID_CANCEL, "Cancel")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onOk, id=wx.ID_OK)
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: BandChoiceDialog.__set_properties
        self.SetTitle("Photometric Bands")
        self.photoComboBox.SetSelection(0)
        self.clearCheckbox.SetValue(1)
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: BandChoiceDialog.__do_layout
        sizer_22 = wx.BoxSizer(wx.VERTICAL)
        sizer_23 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_22.Add(self.photoComboBox, 0, 0, 0)
        sizer_22.Add(self.clearCheckbox, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_23.Add(self.okButton_copy, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_23.Add(self.cancelButton_copy, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_22.Add(sizer_23, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_22)
        sizer_22.Fit(self)
        self.Layout()
        # end wxGlade

    def onOk(self, event): # wxGlade: BandChoiceDialog.<event_handler>
        sel=self.photoComboBox.GetSelection()
        spec = self.Parent.Parent.spec
        if self.clearCheckbox.IsChecked():
            spec.clearPhotoBands()
        if sel == 0: #UBVRI
            #Spectrum.updatePhotoBands(PhotometricBand.UBVRIBands())
            spec.loadStandardBands('UBVRI')
        elif sel == 1: #ugriz
            #Spectrum.updatePhotoBands(PhotometricBand.ugrizBands(primed=False))
            spec.loadStandardBands('ugriz')
        elif sel == 2: #u'g'r'i'z'
            #Spectrum.updatePhotoBands(PhotometricBand.ugrizBands(primed=True))
            spec.loadStandardBands("u'g'r'i'z'")
        event.Skip()

# end of class BandChoiceDialog


class PhotometryFrame(wx.MiniFrame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: PhotometryFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.MiniFrame.__init__(self, *args, **kwds)
        self.bandsCheckbox = wx.CheckBox(self, -1, "Show Photometric Bands")
        self.shiftedCheckbox = wx.CheckBox(self, -1, "Show Redshifted Bands")
        self.photometryButton = wx.Button(self, -1, "Raw Photometry")
        self.kCorrectButton = wx.Button(self, -1, "K Corrections")
        self.bandsButton = wx.Button(self, -1, "Choose Bands...")
        self.zeroPointButton = wx.Button(self, -1, "Set Zero Points")
        self.photoInfoButton = wx.Button(self, -1, "Band Information...")
        self.photoTextCtrl = wx.TextCtrl(self, -1, "", style=wx.TE_MULTILINE|wx.TE_READONLY)

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_CHECKBOX, self.onShowBands, self.bandsCheckbox)
        self.Bind(wx.EVT_CHECKBOX, self.onShowShiftBands, self.shiftedCheckbox)
        self.Bind(wx.EVT_BUTTON, self.onRawPhoto, self.photometryButton)
        self.Bind(wx.EVT_BUTTON, self.onKCorr, self.kCorrectButton)
        self.Bind(wx.EVT_BUTTON, self.onChooseBands, self.bandsButton)
        self.Bind(wx.EVT_BUTTON, self.onZeroPoint, self.zeroPointButton)
        self.Bind(wx.EVT_BUTTON, self.onBandInfo, self.photoInfoButton)
        # end wxGlade
        
        self.Bind(wx.EVT_CLOSE, self.onClose, self)
        
        self.bandsCheckbox.SetValue(self.Parent.drawingSettings.drawBands)
        self.shiftedCheckbox.SetValue(self.Parent.drawingSettings.drawShiftedBands)

    def __set_properties(self):
        # begin wxGlade: PhotometryFrame.__set_properties
        self.SetTitle("Photometry Analysis")
        self.SetSize((371, 237))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: PhotometryFrame.__do_layout
        sizer_19 = wx.BoxSizer(wx.VERTICAL)
        sizer_20 = wx.GridSizer(3, 2, 0, 0)
        sizer_21 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_21.Add(self.bandsCheckbox, 0, 0, 0)
        sizer_21.Add(self.shiftedCheckbox, 0, 0, 0)
        sizer_19.Add(sizer_21, 0, wx.EXPAND, 0)
        sizer_20.Add(self.photometryButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_20.Add(self.kCorrectButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_20.Add(self.bandsButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_20.Add(self.zeroPointButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_20.Add(self.photoInfoButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_19.Add(sizer_20, 0, wx.EXPAND, 0)
        sizer_19.Add(self.photoTextCtrl, 1, wx.EXPAND, 0)
        self.SetSizer(sizer_19)
        self.Layout()
        # end wxGlade
        
    def onClose(self, event):
        #self.cleanup()
        self.Show(False)

        mf=self.GetParent()
        if mf._activeTBar==self:
            mf._activeTBar=None
            mb=mf.GetMenuBar()
            noneSel=mb.FindItemById(301)
            noneSel.Check(True)
        
    def update(self,axes):
        self.bandsCheckbox.SetValue(self.Parent.drawingSettings.drawBands)
        self.shiftedCheckbox.SetValue(self.Parent.drawingSettings.drawShiftedBands)

    def onRawPhoto(self, event): # wxGlade: PhotometryFrame.<event_handler>
        
        bandorder=('AB','U','B','V','R','I','J','H','K','L','M','u','g','r','i','z',"u'","g'","r'","i'","z'")
        phots=self.Parent.spec.getPhotometry(asstring=bandorder)
        colorstr=self.Parent.spec.getColors(asstring=bandorder)
        
        self.photoTextCtrl.Value=phots+'\n\n'+colorstr

    def onKCorr(self, event): # wxGlade: PhotometryFrame.<event_handler>
        kd=self.Parent.spec.kCorrection(bandi=0,editeddata=False)
        kl=['K-correction:']
        bandorder=('U','B','V','R','I','J','H','K','L','M','u','g','r','i','z',"u'","g'","r'","i'","z'")
        for s in bandorder:
            if s in kd:
                kl.append(s+': '+str(kd[s]))
                del kd[s]
        kl.extend([k+': '+str(v) for k,v in kd.iteritems()])
        kl.append('')
        
        #photometry and colors
        kl.append('Corrected Photometry:')
        kl.append(self.Parent.spec.getPhotometry(asstring=bandorder,kcorrect=True))
        kl.append('')
        kl.append('Corrected Colors:')
        kl.append(self.Parent.spec.getColors(asstring=bandorder,kcorrect=True))
        
        self.photoTextCtrl.Value='\n'.join(kl)
        
    def onChooseBands(self, event): # wxGlade: PhotometryFrame.<event_handler>
        dlg=BandChoiceDialog(self,-1)
        if dlg.ShowModal() == wx.ID_OK: #internally does all setting
            self.Parent.updateFigure()
        dlg.Destroy()

    def onShowBands(self, event): # wxGlade: PhotometryFrame.<event_handler>
        self.Parent.drawingSettings.drawBands = self.bandsCheckbox.IsChecked()
        self.Parent.updateFigure()

    def onShowShiftBands(self, event): # wxGlade: PhotometryFrame.<event_handler>
        self.Parent.drawingSettings.drawShiftedBands = self.shiftedCheckbox.IsChecked()
        self.Parent.updateFigure()

    def onZeroPoint(self, event): # wxGlade: PhotometryFrame.<event_handler>
        spec=self.Parent.spec
        d={}
        dlg=wx.MessageDialog(self,'Set zero points from spectrum?','Photometric Zero Points',wx.YES_NO)
        fromspec = dlg.ShowModal() == wx.ID_YES
        dlg.Destroy()
        if not fromspec:
            dlg=wx.MessageDialog(self,'Use AB zero points?','Photometric Zero Points',wx.YES_NO)
            abms = dlg.ShowModal() == wx.ID_YES
            dlg.Destroy()
        else:
            abms = False
        if abms:
            for b in spec.iterPhotoBands():
                b.useABZeropt()
        else:
            for b in spec.iterPhotoBands():
                dlg=wx.TextEntryDialog(self,'Zero point offset from this spectrum for '+b.name+' Band?','Photometric Zero Points','0.0')
                try:
                    if wx.ID_CANCEL == dlg.ShowModal():
                        return
                    d[b.name]=float(dlg.GetValue())
                finally:
                    dlg.Destroy()
            if fromspec:
                spec.definePhotometricZeroPoints(specifiedmags=d)
            else:
                for b in spec.iterPhotoBands():
                    if b.name in d:
                        b.zeropt = d[b.name]

    def onBandInfo(self, event): # wxGlade: PhotometryFrame.<event_handler>
        spec = self.Parent.spec
        bi = spec.iterPhotoBands()
        msg=[]
        les=leff=spec.getLambdaEffs(kcorrect=True)
        for b in bi:
            try:
                msg.append('%s Band zpt:%1.4f FWHM:%1.4f center:%1.4f lambdaeff:%1.4f\n' % (b.name,b.zeropt,b.FWHM(),b.center(),les[b.name]))
            except KeyError: #this means the band is outside the spectrum
                pass
        self.photoTextCtrl.Value='\n'.join(msg)

# end of class PhotometryFrame


class LineListDialog(wx.Dialog):
    def __init__(self,specClass, *args, **kwds):

        self.specs=specClass

        # begin wxGlade: LineListDialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE|wx.RESIZE_BORDER|wx.THICK_FRAME
        wx.Dialog.__init__(self, *args, **kwds)
        self.label_12 = wx.StaticText(self, -1, "Major Lines")
        self.majorListBox = wx.ListBox(self, -1, choices=[], style=wx.LB_MULTIPLE)
        self.majToMatButton = wx.Button(self, -1, ">>")
        self.majToMinButton = wx.Button(self, -1, ">")
        self.majorAddButton = wx.Button(self, -1, "Add...")
        self.majorRemoveButton = wx.Button(self, -1, "Remove")
        self.label_12_copy = wx.StaticText(self, -1, "Minor Lines")
        self.minorListBox = wx.ListBox(self, -1, choices=[], style=wx.LB_MULTIPLE)
        self.minToMajButton = wx.Button(self, -1, "<")
        self.minToMatButton = wx.Button(self, -1, ">")
        self.minorAddButton = wx.Button(self, -1, "Add...")
        self.minorRemoveButton = wx.Button(self, -1, "Remove")
        self.label_12_copy_1 = wx.StaticText(self, -1, "Match Lines")
        self.matchListBox = wx.ListBox(self, -1, choices=[], style=wx.LB_MULTIPLE)
        self.matToMinButton = wx.Button(self, -1, "<")
        self.matToMajButton = wx.Button(self, -1, "<<")
        self.matchAddButton = wx.Button(self, -1, "Add...")
        self.matchRemoveButton = wx.Button(self, -1, "Remove")
        self.loadButton = wx.Button(self, -1, "Load...")
        self.saveButton = wx.Button(self, -1, "Save...")
        self.clearButton = wx.Button(self, -1, "Clear Lines")
        self.duplicateButton = wx.Button(self, -1, "Find Duplicates")
        self.doneButton = wx.Button(self, wx.ID_OK, "Done")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onMajToMat, self.majToMatButton)
        self.Bind(wx.EVT_BUTTON, self.onMajToMin, self.majToMinButton)
        self.Bind(wx.EVT_BUTTON, self.onMajorAdd, self.majorAddButton)
        self.Bind(wx.EVT_BUTTON, self.onMajorRemove, self.majorRemoveButton)
        self.Bind(wx.EVT_BUTTON, self.onMinToMaj, self.minToMajButton)
        self.Bind(wx.EVT_BUTTON, self.onMinToMat, self.minToMatButton)
        self.Bind(wx.EVT_BUTTON, self.onMinorAdd, self.minorAddButton)
        self.Bind(wx.EVT_BUTTON, self.onMinorRemove, self.minorRemoveButton)
        self.Bind(wx.EVT_BUTTON, self.onMatToMin, self.matToMinButton)
        self.Bind(wx.EVT_BUTTON, self.onMatToMaj, self.matToMajButton)
        self.Bind(wx.EVT_BUTTON, self.onMatchAdd, self.matchAddButton)
        self.Bind(wx.EVT_BUTTON, self.onMatchRemove, self.matchRemoveButton)
        self.Bind(wx.EVT_BUTTON, self.onLoadLines, self.loadButton)
        self.Bind(wx.EVT_BUTTON, self.onSaveLines, self.saveButton)
        self.Bind(wx.EVT_BUTTON, self.onClearLines, self.clearButton)
        self.Bind(wx.EVT_BUTTON, self.onDup, self.duplicateButton)
        self.Bind(wx.EVT_BUTTON, self.onDone, id=wx.ID_OK)
        # end wxGlade



    def __set_properties(self):
        # begin wxGlade: LineListDialog.__set_properties
        self.SetTitle("Choose Line Lists")
        self.SetSize((581, 315))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: LineListDialog.__do_layout
        sizer_14 = wx.BoxSizer(wx.VERTICAL)
        sizer_15 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_16 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_16_copy_1 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_17_copy_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_18_copy_1 = wx.GridSizer(2, 2, 0, 0)
        sizer_16_copy = wx.BoxSizer(wx.HORIZONTAL)
        sizer_17_copy = wx.BoxSizer(wx.VERTICAL)
        sizer_18_copy = wx.GridSizer(2, 2, 0, 0)
        sizer_17 = wx.BoxSizer(wx.VERTICAL)
        sizer_18 = wx.GridSizer(2, 2, 0, 0)
        sizer_17.Add(self.label_12, 0, 0, 0)
        sizer_17.Add(self.majorListBox, 1, wx.EXPAND, 0)
        sizer_18.Add(self.majToMatButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_18.Add(self.majToMinButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_18.Add(self.majorAddButton, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_18.Add(self.majorRemoveButton, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_17.Add(sizer_18, 0, wx.EXPAND, 0)
        sizer_16.Add(sizer_17, 1, wx.EXPAND, 0)
        sizer_17_copy.Add(self.label_12_copy, 0, 0, 0)
        sizer_17_copy.Add(self.minorListBox, 1, wx.EXPAND, 0)
        sizer_18_copy.Add(self.minToMajButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_18_copy.Add(self.minToMatButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_18_copy.Add(self.minorAddButton, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_18_copy.Add(self.minorRemoveButton, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_17_copy.Add(sizer_18_copy, 0, wx.EXPAND, 0)
        sizer_16_copy.Add(sizer_17_copy, 1, wx.EXPAND, 0)
        sizer_16.Add(sizer_16_copy, 1, wx.EXPAND, 0)
        sizer_17_copy_1.Add(self.label_12_copy_1, 0, 0, 0)
        sizer_17_copy_1.Add(self.matchListBox, 1, wx.EXPAND, 0)
        sizer_18_copy_1.Add(self.matToMinButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_18_copy_1.Add(self.matToMajButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_18_copy_1.Add(self.matchAddButton, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_18_copy_1.Add(self.matchRemoveButton, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_17_copy_1.Add(sizer_18_copy_1, 0, wx.EXPAND, 0)
        sizer_16_copy_1.Add(sizer_17_copy_1, 1, wx.EXPAND, 0)
        sizer_16.Add(sizer_16_copy_1, 1, wx.EXPAND, 0)
        sizer_14.Add(sizer_16, 1, wx.EXPAND, 0)
        sizer_15.Add(self.loadButton, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_15.Add(self.saveButton, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_15.Add(self.clearButton, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_15.Add(self.duplicateButton, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_14.Add(sizer_15, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_14.Add(self.doneButton, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 5)
        self.SetSizer(sizer_14)
        self.Layout()
        # end wxGlade

        self.__genLists()

    def __genLists(self):
        major,minor,match=self.specs.getLines({},{},{})
        self.majorListBox.Clear()
        self.majorListBox.AppendItems([major[k]+' @ '+str(k) for k in sorted(major)])
        self.minorListBox.Clear()
        self.minorListBox.AppendItems([minor[k]+' @ '+str(k) for k in sorted(minor)])
        self.matchListBox.Clear()
        self.matchListBox.AppendItems([match[k]+' @ '+str(k) for k in sorted(match)])


    def onMajorAdd(self, event): # wxGlade: LineListDialog.<event_handler>
        dlg=wx.TextEntryDialog(self,'New Line Name?','Adding Major Line')
        dlg2=wx.TextEntryDialog(self,'New Line Wavelength?','Adding Major Line')
        try:
            if dlg.ShowModal() == wx.ID_OK and dlg2.ShowModal() == wx.ID_OK:
                self.specs.addMarkLine(float(dlg2.Value),dlg.Value,major=True)
                self.majorListBox.Append(dlg.Value+' @ '+dlg2.Value)
        except ValueError:
            dlg3=wx.MessageDialog(self,'Invalid Line Wavelength Entry - must be convertable to a float','',wx.ID_OK|wx.ICON_ERROR)
            dlg3.ShowModal()
            dlg3.Destroy()
        finally:
            dlg.Destroy()
            dlg2.Destroy()


    def onMajorRemove(self, event): # wxGlade: LineListDialog.<event_handler>
        inds=self.majorListBox.GetSelections()
        for i in sorted(inds,reverse=True):
            wl=float(self.majorListBox.GetString(i).split(' @ ')[1])
            self.specs.removeLine(wl,'major')
            self.majorListBox.Delete(i)

    def onMinorAdd(self, event): # wxGlade: LineListDialog.<event_handler>
        dlg=wx.TextEntryDialog(self,'New Line Name?','Adding Minor Line')
        dlg2=wx.TextEntryDialog(self,'New Line Wavelength?','Adding Minor Line')
        try:
            if dlg.ShowModal() == wx.ID_OK and dlg2.ShowModal() == wx.ID_OK:
                self.specs.addMarkLine(float(dlg2.Value),dlg.Value,major=False)
                self.minorListBox.Append(dlg.Value+' @ '+dlg2.Value)
        except ValueError:
            dlg3=wx.MessageDialog(self,'Invalid Line Wavelength Entry - must be convertable to a float','',wx.ID_OK|wx.ICON_ERROR)
            dlg3.ShowModal()
            dlg3.Destroy()
        finally:
            dlg.Destroy()
            dlg2.Destroy()

    def onMinorRemove(self, event): # wxGlade: LineListDialog.<event_handler>
        inds=self.minorListBox.GetSelections()
        for i in sorted(inds,reverse=True):
            wl=float(self.minorListBox.GetString(i).split(' @ ')[1])
            self.specs.removeLine(wl,'minor')
            self.minorListBox.Delete(i)

    def onMatchAdd(self, event): # wxGlade: LineListDialog.<event_handler>
        dlg=wx.TextEntryDialog(self,'New Line Name?','Adding Match Line')
        dlg2=wx.TextEntryDialog(self,'New Line Wavelength?','Adding Match Line')
        try:
            if dlg.ShowModal() == wx.ID_OK and dlg2.ShowModal() == wx.ID_OK:
                self.specs.addMatchLine(float(dlg2.Value),dlg.Value)
                self.matchListBox.Append(dlg.Value+' @ '+dlg2.Value)
        except ValueError:
            dlg3=wx.MessageDialog(self,'Invalid Line Wavelength Entry - must be convertable to a float','',wx.ID_OK|wx.ICON_ERROR)
            dlg3.ShowModal()
            dlg3.Destroy()
        finally:
            dlg.Destroy()
            dlg2.Destroy()

    def onMatchRemove(self, event): # wxGlade: LineListDialog.<event_handler>
        inds=self.matchListBox.GetSelections()
        for i in sorted(inds,reverse=True):
            wl=float(self.matchListBox.GetString(i).split(' @ ')[1])
            self.specs.removeLine(wl,'match')
            self.matchListBox.Delete(i)

    def onLoadLines(self, event): # wxGlade: LineListDialog.<event_handler>
        dlg=wx.FileDialog(self,'Choose a line list file to load',style=wx.OPEN)
        try:
            if dlg.ShowModal()==wx.ID_OK:
                self.specs.loadLineList(dlg.Path)
                self.__genLists()
        finally:
            dlg.Destroy()

    def onSaveLines(self, event): # wxGlade: LineListDialog.<event_handler>
        dlg=wx.FileDialog(self,'Choose a line list file to load',style=wx.SAVE)
        dlg2=wx.MessageDialog(self,'Include type column in list list?','Type?',wx.YES_NO|wx.ICON_QUESTION)
        try:
            if dlg.ShowModal()==wx.ID_OK:
                self.specs.saveLineList(dlg.Path,type=dlg2.ShowModal() == wx.ID_YES)
        finally:
            dlg.Destroy()
            dlg2.Destroy()


    def onClearLines(self, event): # wxGlade: LineListDialog.<event_handler>
        self.specs.clearLineLists()
        self.__genLists()

    def onDone(self, event): # wxGlade: LineListDialog.<event_handler>
        self.specs.rebuildLineListCache()
        event.Skip()

    def onDup(self, event): # wxGlade: LineListDialog.<event_handler>
        from wx.lib.dialogs import ScrolledMessageDialog
        dlg=wx.TextEntryDialog(self,'Wavelength Tolerance?','Tolerance','0')
        try:
            if dlg.ShowModal()==wx.ID_OK:
                res=self.specs.cleanLineListDuplicates(tolerance=float(dlg.Value),remove=True,keepsametype=False)
                stl=['Removed:']
                for wl,d in res:
                    stl.append('line @ '+str(wl)+' in '+d+' list')
                dlg2=ScrolledMessageDialog(self,'\n'.join(stl),'Removed Lines')
                dlg2.ShowModal()
                dlg2.Destroy()
        finally:
            dlg.Destroy()

    def onMajToMin(self, event): # wxGlade: LineListDialog.<event_handler>
        for i in sorted(self.majorListBox.GetSelections(),reverse=True):
            t=self.majorListBox.GetString(i).split(' @ ')
            wl=float(t[1])
            self.specs.removeLine(wl,'major')
            self.specs.addMarkLine(wl,t[0],major=False)
        self.__genLists()

    def onMinToMaj(self, event): # wxGlade: LineListDialog.<event_handler>
        for i in sorted(self.minorListBox.GetSelections(),reverse=True):
            t=self.minorListBox.GetString(i).split(' @ ')
            wl=float(t[1])
            self.specs.removeLine(wl,'minor')
            self.specs.addMarkLine(wl,t[0],major=True)
        self.__genLists()

    def onMinToMat(self, event): # wxGlade: LineListDialog.<event_handler>
        for i in sorted(self.minorListBox.GetSelections(),reverse=True):
            t=self.minorListBox.GetString(i).split(' @ ')
            wl=float(t[1])
            self.specs.removeLine(wl,'minor')
            self.specs.addMatchLine(wl,t[0])
        self.__genLists()

    def onMatToMin(self, event): # wxGlade: LineListDialog.<event_handler>
        for i in sorted(self.matchListBox.GetSelections(),reverse=True):
            t=self.matchListBox.GetString(i).split(' @ ')
            wl=float(t[1])
            self.specs.removeLine(wl,'match')
            self.specs.addMarkLine(wl,t[0],major=False)
        self.__genLists()

    def onMajToMat(self, event): # wxGlade: LineListDialog.<event_handler>
        for i in sorted(self.majorListBox.GetSelections(),reverse=True):
            t=self.majorListBox.GetString(i).split(' @ ')
            wl=float(t[1])
            self.specs.removeLine(wl,'major')
            self.specs.addMatchLine(wl,t[0])
        self.__genLists()

    def onMatToMaj(self, event): # wxGlade: LineListDialog.<event_handler>
        for i in sorted(self.matchListBox.GetSelections(),reverse=True):
            t=self.matchListBox.GetString(i).split(' @ ')
            wl=float(t[1])
            self.specs.removeLine(wl,'match')
            self.specs.addMarkLine(wl,t[0],major=True)
        self.__genLists()

# end of class LineListDialog


class LineAppearDialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        from wx.lib.colourselect import ColourSelect as ColorSelector
        try:
            sets=args[0].drawingSettings
        except:
            pass #let the initializer decide what to do if the Parent argument is wrong
        # begin wxGlade: LineAppearDialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, "")
        self.label_2 = wx.StaticText(self, -1, "Color")
        self.label_3 = wx.StaticText(self, -1, "Style")
        self.label_4 = wx.StaticText(self, -1, "Spectrum")
        self.specColorSelector = ColorSelector(self, -1, '', self.colorF2I(sets.plotColor))
        self.specStyleTextCtrl = wx.TextCtrl(self, -1, "")
        self.label_5 = wx.StaticText(self, -1, "Major Lines")
        self.majorColorSelector = ColorSelector(self, -1, '', self.colorF2I(sets.majorColor))
        self.majorStyleTextCtrl = wx.TextCtrl(self, -1, "")
        self.label_6 = wx.StaticText(self, -1, "Minor Lines")
        self.minorColorSelector = ColorSelector(self, -1, '', self.colorF2I(sets.minorColor))
        self.minorStyleTextCtrl = wx.TextCtrl(self, -1, "")
        self.label_6_copy_copy = wx.StaticText(self, -1, "Overplot")
        self.overplotColorSelector = ColorSelector(self, -1, '', self.colorF2I(sets.overplotColor))
        self.overplotStyleTextCtrl = wx.TextCtrl(self, -1, "")
        self.label_6_copy = wx.StaticText(self, -1, "Photo Lines")
        self.photoStyleTextCtrl = wx.TextCtrl(self, -1, "")
        self.label_6_copy_1 = wx.StaticText(self, -1, "Shift Lines")
        self.shiftStyleTextCtrl = wx.TextCtrl(self, -1, "")
        self.label_11 = wx.StaticText(self, -1, "")
        self.label_10 = wx.StaticText(self, -1, "Color")
        self.label_9 = wx.StaticText(self, -1, "Transparency")
        self.label_7 = wx.StaticText(self, -1, "Feature")
        self.featureColorSelector = ColorSelector(self, -1, '', self.colorF2I(sets.featureColor))
        self.featureAlphaTextCtrl = wx.TextCtrl(self, -1, "")
        self.label_8 = wx.StaticText(self, -1, "Feature Edge")
        self.featureEdgeColorSelector = ColorSelector(self, -1, '', self.colorF2I(sets.featureEdgeColor))
        self.okButton = wx.Button(self, wx.ID_OK, "Ok")
        self.cancelButton = wx.Button(self, wx.ID_CANCEL, "Cancel")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onOk, id=wx.ID_OK)
        # end wxGlade

        #set values of text from Spectrum settings

        self.specStyleTextCtrl.Value=sets.plotStyle
        self.majorStyleTextCtrl.Value=sets.majorStyle
        self.minorStyleTextCtrl.Value=sets.minorStyle
        self.overplotStyleTextCtrl.Value=sets.overplotStyle
        self.photoStyleTextCtrl.Value=sets.bandStyle
        self.shiftStyleTextCtrl.Value=sets.shiftBandStyle
        self.featureAlphaTextCtrl.Value=str(sets.featureAlpha)

    def __set_properties(self):
        # begin wxGlade: LineAppearDialog.__set_properties
        self.SetTitle("Line Appearence")
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: LineAppearDialog.__do_layout
        sizer_12 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.HORIZONTAL)
        grid_sizer_3 = wx.FlexGridSizer(10, 3, 0, 0)
        grid_sizer_3.Add(self.label_1, 0, 0, 0)
        grid_sizer_3.Add(self.label_2, 0, 0, 0)
        grid_sizer_3.Add(self.label_3, 0, 0, 0)
        grid_sizer_3.Add(self.label_4, 0, 0, 0)
        grid_sizer_3.Add(self.specColorSelector, 1, wx.EXPAND, 0)
        grid_sizer_3.Add(self.specStyleTextCtrl, 0, 0, 0)
        grid_sizer_3.Add(self.label_5, 0, 0, 0)
        grid_sizer_3.Add(self.majorColorSelector, 1, wx.EXPAND, 0)
        grid_sizer_3.Add(self.majorStyleTextCtrl, 0, 0, 0)
        grid_sizer_3.Add(self.label_6, 0, 0, 0)
        grid_sizer_3.Add(self.minorColorSelector, 1, wx.EXPAND, 0)
        grid_sizer_3.Add(self.minorStyleTextCtrl, 0, 0, 0)
        grid_sizer_3.Add(self.label_6_copy_copy, 0, 0, 0)
        grid_sizer_3.Add(self.overplotColorSelector, 1, wx.EXPAND, 0)
        grid_sizer_3.Add(self.overplotStyleTextCtrl, 0, 0, 0)
        grid_sizer_3.Add(self.label_6_copy, 0, 0, 0)
        grid_sizer_3.Add((20, 20), 0, 0, 0)
        grid_sizer_3.Add(self.photoStyleTextCtrl, 0, 0, 0)
        grid_sizer_3.Add(self.label_6_copy_1, 0, 0, 0)
        grid_sizer_3.Add((20, 20), 0, 0, 0)
        grid_sizer_3.Add(self.shiftStyleTextCtrl, 0, 0, 0)
        grid_sizer_3.Add(self.label_11, 0, 0, 0)
        grid_sizer_3.Add(self.label_10, 0, 0, 0)
        grid_sizer_3.Add(self.label_9, 0, 0, 0)
        grid_sizer_3.Add(self.label_7, 0, 0, 0)
        grid_sizer_3.Add(self.featureColorSelector, 1, wx.EXPAND, 0)
        grid_sizer_3.Add(self.featureAlphaTextCtrl, 0, 0, 0)
        grid_sizer_3.Add(self.label_8, 0, 0, 0)
        grid_sizer_3.Add(self.featureEdgeColorSelector, 1, wx.EXPAND, 0)
        sizer_12.Add(grid_sizer_3, 0, wx.EXPAND, 0)
        sizer_13.Add(self.okButton, 0, wx.ALL, 5)
        sizer_13.Add(self.cancelButton, 0, wx.ALL, 5)
        sizer_12.Add(sizer_13, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_12)
        sizer_12.Fit(self)
        self.Layout()
        # end wxGlade

    def colorF2I(self,intuple):
        return (int(intuple[0]*255),int(intuple[1]*255),int(intuple[2]*255))

    def colorI2F(self,intuple):
        return (intuple[0]/255.0,intuple[1]/255.0,intuple[2]/255.0)

    def applySettings(self,applyto):
        #applyto is a spylot.SpectrumDrawingSettings object
        applyto.plotStyle=str(self.specStyleTextCtrl.Value)
        applyto.majorStyle=str(self.majorStyleTextCtrl.Value)
        applyto.minorStyle=str(self.minorStyleTextCtrl.Value)
        applyto.overplotStyle=(self.overplotStyleTextCtrl.Value)
        applyto.bandStyle=str(self.photoStyleTextCtrl.Value)
        applyto.shiftBandStyle=str(self.shiftStyleTextCtrl.Value)
        applyto.featureAlpha=float(self.featureAlphaTextCtrl.Value)

        applyto.plotColor=self.colorI2F(self.specColorSelector.GetColour())
        applyto.majorColor=self.colorI2F(self.majorColorSelector.GetColour())
        applyto.minorColor=self.colorI2F(self.minorColorSelector.GetColour())
        applyto.featureColor=self.colorI2F(self.featureColorSelector.GetColour())
        applyto.overplotColor=self.colorI2F(self.overplotColorSelector.GetColour())
        applyto.featureEdgeColor=self.colorI2F(self.featureEdgeColorSelector.GetColour())

    def onOk(self, event): # wxGlade: LineAppearDialog.<event_handler>
        oldset=self.Parent.drawingSettings.copy()
        self.applySettings(self.Parent.drawingSettings)
        try:
            self.Parent.drawingSettings.drawMarks=True
            self.Parent.updateFigure()
        except Exception,e:
            #this signifies an inappropriate linestyle
            self.Parent.drawingSettings.update(oldset)
            dlg=wx.MessageDialog(self,'Inappropriate Linestyle:\n'+str(e),'Invalid Entry',wx.OK|wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
        else:
            self.Parent.drawingSettings.drawMarks=oldset.drawMarks
            event.Skip()

# end of class LineAppearDialog


class LineAnalysisFrame(wx.MiniFrame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: LineAnalysisFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.MiniFrame.__init__(self, *args, **kwds)
        self.zCalcButton = wx.Button(self, -1, "Calculate Z\nfrom Lines")
        self.fixZIntCheckBox = wx.CheckBox(self, -1, "Fix Intercept to 0?")
        self.fitLinesButton = wx.Button(self, -1, "Fit Lines")
        self.autoLineButton = wx.Button(self, -1, "Auto Line\nFinder...")
        self.drawLineCheckBox = wx.CheckBox(self, -1, "Draw Line Ranges?")
        self.centroidButton = wx.Button(self, -1, "Centroid Lines")
        self.markMajorButton = wx.Button(self, -1, "Mark Major Lines")
        self.markMinorButton = wx.Button(self, -1, "Mark Minor Lines")
        self.lineStatsButton = wx.Button(self, -1, "Line Stats")
        self.removeButton = wx.Button(self, -1, "Remove Lines")
        self.idLineButton = wx.Button(self, -1, "ID Lines")
        self.lineLister = wx.ListBox(self, -1, choices=[], style=wx.LB_MULTIPLE)

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onZCalc, self.zCalcButton)
        self.Bind(wx.EVT_BUTTON, self.onFit, self.fitLinesButton)
        self.Bind(wx.EVT_BUTTON, self.onAutoLine, self.autoLineButton)
        self.Bind(wx.EVT_CHECKBOX, self.onDrawLine, self.drawLineCheckBox)
        self.Bind(wx.EVT_BUTTON, self.onCentroid, self.centroidButton)
        self.Bind(wx.EVT_BUTTON, self.onMarkMajor, self.markMajorButton)
        self.Bind(wx.EVT_BUTTON, self.onMarkMinor, self.markMinorButton)
        self.Bind(wx.EVT_BUTTON, self.onLineStats, self.lineStatsButton)
        self.Bind(wx.EVT_BUTTON, self.onRemove, self.removeButton)
        self.Bind(wx.EVT_BUTTON, self.onID, self.idLineButton)
        # end wxGlade
        
        #custom events
        self.Bind(wx.EVT_CLOSE,self.onClose,self)
        self.Bind(wx.EVT_SHOW,self.onShow,self)
        
        #TODO:make sure this is safe
        #self.Parent.figureNavToolbar.addToolListener(self.onToolToggle)
        
        #instance variables
        self.seltool = None
        
        
        #to keep spectrum in sync with drawing on instantiation
        self.Parent.drawingSettings.drawFeatureSpans=self.drawLineCheckBox.IsChecked()


    def __set_properties(self):
        # begin wxGlade: LineAnalysisFrame.__set_properties
        self.SetTitle("Line Analysis Toolbar")
        self.fixZIntCheckBox.SetValue(1)
        self.drawLineCheckBox.SetValue(1)
        self.lineLister.SetMinSize((1, 150))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: LineAnalysisFrame.__do_layout
        sizer_10 = wx.BoxSizer(wx.VERTICAL)
        grid_sizer_2 = wx.GridSizer(3, 3, 1, 1)
        sizer_11 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.VERTICAL)
        sizer_8.Add(self.zCalcButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_8.Add(self.fixZIntCheckBox, 0, 0, 0)
        grid_sizer_2.Add(sizer_8, 1, wx.EXPAND, 0)
        grid_sizer_2.Add(self.fitLinesButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_2.Add(self.autoLineButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_2.Add(self.drawLineCheckBox, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_2.Add(self.centroidButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_11.Add(self.markMajorButton, 0, wx.BOTTOM|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 2)
        sizer_11.Add(self.markMinorButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_2.Add(sizer_11, 1, wx.EXPAND, 0)
        grid_sizer_2.Add(self.lineStatsButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_2.Add(self.removeButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_2.Add(self.idLineButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_10.Add(grid_sizer_2, 0, wx.EXPAND, 0)
        sizer_10.Add(self.lineLister, 1, wx.EXPAND, 0)
        self.SetSizer(sizer_10)
        sizer_10.Fit(self)
        self.Layout()
        self.Centre()
        # end wxGlade

    def onClose(self, event):
        self.cleanup()
        self.Show(False)

        mf=self.GetParent()
        if mf._activeTBar==self:
            mf._activeTBar=None
            mb=mf.GetMenuBar()
            noneSel=mb.FindItemById(301)
            noneSel.Check(True)

        #mostly to just make sure the feature lines get hidden
        self.Parent.updateFigure()

    def onShow(self, event):
        if event.GetShow():
            self.update(self.GetParent().axes)
            self.Parent.figureNavToolbar.addToolListener(self.onToolToggle)
            self.__cid=self.Parent.fig.canvas.mpl_connect('button_press_event', self.b3Press)
            self.Parent.updateFigure()
        else:
            self.cleanup()
            try:
                self.Parent.figureNavToolbar.removeToolListener(self.onToolToggle)
            except wx.PyDeadObjectError:
                #this just means the canvas has already been Destroyed, so no events will be processed anyway
                pass
            
        event.Skip()

    def update(self,axes):
        sets=self.Parent.drawingSettings
        try:
            self.seltool.new_axes(axes)
        except: #try/except for compatibility with matplotlib < 91.3 SpanSelector
            self.seltool=SpanSelector(axes,self.onSelect,'horizontal',minspan=self.Parent.spec.getWlSoln()[1],rectprops=sets.getFeatureRectProps(),useblit=True)
        #need to check nav bar for tools toggled on and have the seltool be disabled if so
        self.seltool.visible = not self.Parent.figureNavToolbar.getToolState()
        sets.drawFeatureSpans=self.drawLineCheckBox.IsChecked()
        self.updateList(nofig=True)


    def updateList(self,nofig=False):
        #TODO: do this more efficiently?
        spec=self.Parent.spec
        fi = spec.getFeatureIter()
        if fi is not None:
            self.lineLister.SetItems([str(e) for e in fi])
        else:
            self.lineLister.SetItems([])

        if self.Parent.drawingSettings.drawFeatureSpans and not nofig:
            self.Parent.updateFigure()

    def cleanup(self):
        self.seltool.visible=False
        self.Parent.drawingSettings.drawFeatureSpans=False
        try:
            self.Parent.fig.canvas.mpl_disconnect(self.__cid)
        except wx.PyDeadObjectError:
            #this just means the canvas has already been Destroyed, so no events will be processed anyway
            pass

    def onToolToggle(self,state): #custom navbar event
        if self.seltool is not None:
            self.seltool.visible = not state
        if state:
            self.Parent.fig.canvas.mpl_disconnect(self.__cid)
        else:
            self.__cid=self.Parent.fig.canvas.mpl_connect('button_press_event', self.b3Press)

    def onSelect(self,xMin,xMax):
        self.Parent.spec.addFeatures(xMin,xMax)
        self.updateList()

    def b3Press(self, event): #handler for button presses in the axes for button three
        if event.button==3:
            spec=self.Parent.spec
            spec.locateFeatures(event.xdata,finding='0' if spec.isContinuumSubtracted() else 'd')
            self.updateList()

    def onZCalc(self, event): # wxGlade: LineAnalysisFrame.<event_handler>
        sels=self.lineLister.GetSelections()
        if len(sels)==0:
            sels=range(self.lineLister.GetCount())

        spec=self.Parent.spec
        try:
            res=spec.determineZFromFeatures(sels,freeint=not self.fixZIntCheckBox.IsChecked(),apply=False)
        except ValueError:
            #This means too few features are available for the fit
            res=(0,0,None)

        if res==(0,0,None):
            dlg = wx.MessageDialog(self,'Too few features have identified rest wavelengths, so redshift solution is impossible.',
            'Redshift Solution',wx.OK | wx.ICON_WARNING)
            dlg.ShowModal()
            dlg.Destroy()
        else:
            print res[2]
            spec.zfitinfo=res[2]
            dlg = wx.MessageDialog(self, 'Computed Redshift of '+str(res[0])+' with error '+
            str(res[1])+' from '+str(len(sels))+' features. Accept?','Redshift Solution',wx.YES_NO | wx.ICON_QUESTION)
            if dlg.ShowModal() == wx.ID_YES:
                spec.z=res[0]
                spec.zerr=res[1]
                self.Parent.updateZ()
            dlg.Destroy()

    def onLineStats(self, event): # wxGlade: LineAnalysisFrame.<event_handler>
        sels=self.lineLister.GetSelections()
        if len(sels)==0:
            sels=range(self.lineLister.GetCount())
        spec=self.Parent.spec
        csub=spec.isContinuumSubtracted()
        
        sl=[]
        spec.getCurrentDX(usecache=False)
        for i in sels:
            f=spec.getFeatureByIndex(i)
            sl.append(str(f))
            sl.append('\n')
            sl.append(spec.getStatsString((f.lowerwl,f.upperwl),devmean = 0 if csub else 'g',bandi=0,dxcache=True))
            if f.fitinfo is not None:
                fi=f.fitinfo
                if 'flux' in fi:
                    sl.append('\nFitted Flux: '+str(fi['flux']))
                if 'eqw' in fi:
                    sl.append('\nFitted Equivalent Width: '+str(fi['eqw']))
            sl.append('\n\n')
            
        from wx.lib.dialogs import ScrolledMessageDialog
        dlg = ScrolledMessageDialog(self, ''.join(sl),'Line Statistics')
        
        #ensures dialog is destroyed when it goes away
        def onShow(event):
            if event.Show:
                event.Skip()
            else:
                event.GetEventObject().Destroy()
        dlg.Bind(wx.EVT_SHOW,onShow,dlg)
        dlg.Show()
        spec.setFeatureStats()

    def onRemove(self, event): # wxGlade: LineAnalysisFrame.<event_handler>
        #for some reason the selections come out as a 1-element list of tuples
        sels=self.lineLister.GetSelections()
        if len(sels)==0:
            dlg=wx.MessageDialog(self,"This will clear all lines - are you sure?","Removing all lines",wx.ICON_EXCLAMATION|wx.YES_NO)
            if dlg.ShowModal() == wx.ID_YES:
                self.Parent.spec.clearFeatures()
            dlg.Destroy()
        else:
            self.Parent.spec.removeFeatures(sels)
        self.updateList()


    def onID(self, event): # wxGlade: LineAnalysisFrame.<event_handler>
        sels=self.lineLister.GetSelections()
        if len(sels)==0:
            sels=range(self.lineLister.GetCount())

        spec=self.Parent.spec
        numtomatch=self.Parent._numtomatch
        for i in sels:
            f=spec.getFeatureByIndex(i)
            dlg = wx.SingleChoiceDialog(self,
             'Choose a line for Feature in range ('+str(f.lowerwl)+','+str(f.upperwl)+
            ')\nMatches are given as name, rest wavelength, delta',
            'ID Feature',
            [e[0]+', '+str(e[1])+', '+str(e[2]) for e in spec.identifyFeature(i,numtomatch=numtomatch)],
            wx.CHOICEDLG_STYLE)

            if dlg.ShowModal() == wx.ID_OK:
                choiceidx=dlg.GetSelection()
                spec.identifyFeature(i,selection=choiceidx,numtomatch=choiceidx+1)

            dlg.Destroy()

        self.updateList()

    def onFit(self, event): # wxGlade: LineAnalysisFrame.<event_handler>
        sels=self.lineLister.GetSelections()
        if len(sels)==0:
            sels=range(self.lineLister.GetCount())
        spec=self.Parent.spec
        csub=spec.isContinuumSubtracted()
        
        spec.getCurrentDX(usecache=False)
        for i in sels:
            f=spec.getFeatureByIndex(i)
            
            slc=spec.getSliceFromXRange((f.lowerwl,f.upperwl))
            x=spec.getCurrentXAxis()[slc]
            dx=spec.getCurrentDX(usecache=True)[slc]
            y=spec.getCurrentData(0)[slc]
            dlg = FitDialog(x,y,('gauss','lorentz','voigt','2gauss'),self,-1)
            if dlg.ShowModal() == wx.ID_OK:
                params=dlg.getFitParams()
                
                if 'C' in params:
                    flux=((dlg.getFit()-params['C'])*dx).sum()
                    continuum=params['C']
                else:
                    flux=(dlg.getFit()*dx).sum()
                    continuum=d['flux']/(d['eqw']+d['width'])
                
                err=dlg.getFitRMSDev()
                eqw=flux/continuum
                extras=dlg.getFitExtras()
                
                donormalfitinfo=True
                if 'B' in params:
                    from numpy import exp,pi,abs
                    donormalfitinfo=False
                    #These allow for basing against zero, but we want the fits to not include C
                    #Afit=params['C']+abs(params['A'])*exp(-(x-params['muA'])**2/(2*params['sigmaA']))*(2*pi*params['sigmaA'])**-0.5
                    #Bfit=params['C']-abs(params['B'])*exp(-(x-params['muB'])**2/(2*params['sigmaB']))*(2*pi*params['sigmaB'])**-0.5
                    Afit=abs(params['A'])*exp(-(x-params['muA'])**2/(2*params['sigmaA']))*(2*pi*params['sigmaA'])**-0.5
                    Bfit=-abs(params['B'])*exp(-(x-params['muB'])**2/(2*params['sigmaB']))*(2*pi*params['sigmaB'])**-0.5
                    
                    fluxA=(Afit*dx).sum()
                    fluxB=(Bfit*dx).sum()
                    cenA=params['muA']
                    cenB=params['muB']
                    
                    #TODO:decide if this is necessary
                    #d=spec.getStatsDict((f.lowerwl,f.upperwl),bandi=0,dxcache=True)
                    
                    #works ofr basing against zero
                    #continuum=d['flux']/(d['eqw']+d['width'])
                    continuum=params['C']
                    eqwA=fluxA/continuum
                    eqwB=fluxB/continuum
                    
                    flux=fluxA+fluxB
                    eqw=flux/continuum
                    cen=(cenA+cenB)/2
                    message= "Want to save this fit's flux(%0.5g/%0.5g) and center(%0.5g/%0.5g)?"%(fluxA,fluxB,cenA,cenB)
                else:
                    cen=params['mu']
                    message= "Want to save this fit's flux(%0.5g) and center(%0.5g)?"%(flux,cen)
                    
                            
                        
                        
                dlg2=wx.MessageDialog(self,message,'Save Fit data?',wx.YES_NO|wx.ICON_QUESTION)
                if dlg2.ShowModal()== wx.ID_YES:
                    dlg3=wx.MessageDialog(self,'Want to Split Double Gaussian into two lines?','Split Gaussian?',wx.YES_NO|wx.ICON_QUESTION)
                    if 'B' in params and dlg3.ShowModal() == wx.ID_YES:
                        f.fitinfo={'eqw':eqwA,'flux':fluxA,'fiterr':err,'params':params}
                        f.centerwl=cenA
                        f2=f.copy()
                        f2.fitinfo={'eqw':eqwB,'flux':fluxB,'fiterr':err,'params':params}
                        f2.centerwl=cenB
                        spec.appendSpecFeature(f2)
                        
                        self.updateList()
                    else:
                        f.fitinfo={'eqw':eqw,'flux':flux,'fiterr':err,'params':params}
                        f.centerwl=cen
                    dlg3.Destroy()
                    d=spec.getStatsDict((f.lowerwl,f.upperwl),bandi=0)
                    #TODO:make sure all still owrks    
                    #if donormalfitinfo:
                    #    d=spec.getStatsDict((f.lowerwl,f.upperwl),bandi=0)
                    #    
                    #    #f.fitinfo={'eqw':eqw,'flux':flux,'fiterr':err,'params':params,'extras':extras}
                    #    f.fitinfo={'eqw':eqw,'flux':flux,'fiterr':err,'params':params}
                    #    
                    #    f.centerwl=params['mu']
                        
                dlg2.Destroy()
                
                displsl=[]
                displsl.append('Fit Params: ')
                displsl.append(str(dlg.getFitParams()))
                displsl.append('\nRMS Deviation:')
                displsl.append(str(dlg.getFitRMSDev()))
                displsl.append('\nExtra Fit Parameters:')
                displsl.append(str(dlg.getFitParams()))
                displsl.append('\nExtra Fit information:')
                displsl.append(str(dlg.getFitExtras()))
                #self.secAnaTextCtrl.Value.append('\n'+'\n'.join(displsl))
            dlg.Destroy()
        
        self.updateList()

    def onCentroid(self, event): # wxGlade: LineAnalysisFrame.<event_handler>
        sels=self.lineLister.GetSelections()
        if len(sels)==0:
            sels=range(self.lineLister.GetCount())
        spec=self.Parent.spec
        csub=spec.isContinuumSubtracted()
        
        spec.getCurrentDX(usecache=False)
        for i in sels:
            f=spec.getFeatureByIndex(i)
            #snr,flux,eqw,peakval,width,rmsdev,mean,samples,centroid,center=spec.getStats((f.lowerwl,f.upperwl),devmean = 0 if csub else 'g')
            #f.centerwl=centroid
            f.centerwl=spec.getStatsDict((f.lowerwl,f.upperwl),devmean = 0 if csub else 'g',bandi=0,dxcache=True)['centroid']

        self.updateList()

    def onDrawLine(self, event): # wxGlade: LineAnalysisFrame.<event_handler>
        self.Parent.drawingSettings.drawFeatureSpans=self.drawLineCheckBox.IsChecked()
        self.Parent.updateFigure()

    def onAutoLine(self, event): # wxGlade: LineAnalysisFrame.<event_handler>
        spec=self.Parent.spec
        dlg1=wx.TextEntryDialog(self,'Number of SDs?','Auto Line-Finder Parameters','1')
        dlg2=wx.TextEntryDialog(self,'Window size?','Auto Line-Finder Parameters','0')
        dlg3=wx.TextEntryDialog(self,'LocateFeature algorithm?','Auto Line-Finder Parameters','0' if spec.isContinuumSubtracted() else 'd' )
        if dlg1.ShowModal() == wx.ID_OK and dlg2.ShowModal() == wx.ID_OK and dlg3.ShowModal() == wx.ID_OK:
            sd=float(dlg1.GetValue())
            wind=int(dlg2.GetValue())
            find=dlg3.GetValue()
            dlg1.Destroy()
            dlg2.Destroy()
            dlg3.Destroy()
            
            spec.autoLocateFeatures(sds=sd,window=wind,finding=find,add=True)
            self.updateList()

    def onMarkMajor(self, event): # wxGlade: LineAnalysisFrame.<event_handler>
        self.Parent.spec.locateFromLineLists('major')
        self.updateList()

    def onMarkMinor(self, event): # wxGlade: LineAnalysisFrame.<event_handler>
        self.Parent.spec.locateFromLineLists('minor')
        self.updateList()

# end of class LineAnalysisFrame


class SectionAnalysisFrame(wx.MiniFrame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: SectionAnalysisFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.MiniFrame.__init__(self, *args, **kwds)
        self.statsButton = wx.Button(self, -1, "SNR/Stats")
        self.fitButton = wx.Button(self, -1, "Fit...")
        self.setDataButton = wx.Button(self, -1, "Set Data...")
        self.secAnaTextCtrl = wx.TextCtrl(self, -1, "", style=wx.TE_MULTILINE|wx.TE_READONLY)

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onStats, self.statsButton)
        self.Bind(wx.EVT_BUTTON, self.onFit, self.fitButton)
        self.Bind(wx.EVT_BUTTON, self.onSetData, self.setDataButton)
        # end wxGlade

        #custom events
        self.Bind(wx.EVT_CLOSE,self.onClose,self)
        self.Bind(wx.EVT_SHOW,self.onShow,self)

        #instance variables
        self.__xLims = None
        self.seltool = None

    def __set_properties(self):
        # begin wxGlade: SectionAnalysisFrame.__set_properties
        self.SetTitle("Section Analysis Toolbar")
        self.SetSize((285, 280))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: SectionAnalysisFrame.__do_layout
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        grid_sizer_1 = wx.GridSizer(3, 3, 1, 1)
        grid_sizer_1.Add(self.statsButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(self.fitButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(self.setDataButton, 0, 0, 0)
        sizer_7.Add(grid_sizer_1, 0, wx.EXPAND, 0)
        sizer_7.Add(self.secAnaTextCtrl, 1, wx.EXPAND, 0)
        self.SetSizer(sizer_7)
        self.Layout()
        self.Centre()
        # end wxGlade

    def onToolToggle(self,state): #custom navbar event
        if self.seltool is not None:
            self.seltool.visible = not state

    def onClose(self, event):
        self.cleanup()
        self.Show(False)

        mf=self.GetParent()
        if mf._activeTBar==self:
            mf._activeTBar=None
            mb=mf.GetMenuBar()
            noneSel=mb.FindItemById(301)
            noneSel.Check(True)

    def onShow(self, event):
        if event.GetShow():
            self.update(self.GetParent().axes)
            self.Parent.figureNavToolbar.addToolListener(self.onToolToggle)
        else:
            self.cleanup()
            try:
                self.Parent.figureNavToolbar.removeToolListener(self.onToolToggle)
            except wx.PyDeadObjectError:
                #this just means the canvas has already been Destroyed, so no events will be processed anyway
                pass
        event.Skip()

    def update(self,axes):
        sets=self.Parent.drawingSettings
        try: #try/except for compatibility with matplotlib < 91.3 SpanSelector
            self.seltool.new_axes(axes)
        except:
            self.seltool=SpanSelector(axes,self.onSelect,'horizontal',minspan=self.Parent.spec.getWlSoln()[1],rectprops=sets.getFeatureRectProps(),useblit=True)
        #set visibility status of seltool
        self.seltool.visible = not self.Parent.figureNavToolbar.getToolState()

    def cleanup(self):
        if self.seltool is not None:
            self.seltool.visible=False

    def onSelect(self,xMin,xMax):
        self.__xLims = (xMin,xMax)
        self.secAnaTextCtrl.Value='Selection Bounds:\t%f,%f' % self.__xLims

    def onStats(self, event): # wxGlade: SectionAnalysisFrame.<event_handler>
        if self.__xLims is None:
            self.secAnaTextCtrl.Value='No Selection Region!'
        else:
            self.secAnaTextCtrl.Value+='\n\n'
            self.secAnaTextCtrl.Value+=self.Parent.spec.getStatsString(self.__xLims)

    def onFit(self, event): # wxGlade: SectionAnalysisFrame.<event_handler>
        if self.__xLims is None:
            self.secAnaTextCtrl.Value='No Selection Region!'
        else:
            slc=self.Parent.spec.getSliceFromXRange(self.__xLims)
            x=self.Parent.spec.getCurrentXAxis()[slc]
            y=self.Parent.spec.getCurrentData()[slc]
            dlg = FitDialog(x,y,('gauss','lorentz','voigt','2gauss'),self,-1)
            if dlg.ShowModal() == wx.ID_OK:
                displsl=[]
                displsl.append('Fit Params: ')
                displsl.append(str(dlg.getFitParams()))
                displsl.append('\nRMS Deviation:')
                displsl.append(str(dlg.getFitRMSDev()))
                displsl.append('\nExtra Fit information:')
                displsl.append(str(dlg.getFitExtras()))
                self.secAnaTextCtrl.Value+=('\n'+'\n'.join(displsl))
            dlg.Destroy()
            
    def onSetData(self, event): # wxGlade: SectionAnalysisFrame.<event_handler>
        dlg=wx.TextEntryDialog(self,"Value to set this range to?  Can be 'mean','median', or a value.",'Set Data','mean')
        if dlg.ShowModal() == wx.ID_OK:
            try:
                mf=self.Parent
                slc=mf.spec.getSliceFromXRange(self.__xLims)
                mf.spec.setCurrentData(bandi=None,value=dlg.GetValue(),range=self.__xLims)
                mf.updateFigure()
            except Exception,e:
                dlg2=wx.MessageDialog(self,'Problem setting data:\n'+str(e),"Can't set data",wx.ICON_ERROR)
                dlg2.ShowModal()
                dlg2.Destroy()
        dlg.Destroy()

    def onPhoto(self, event): # wxGlade: SectionAnalysisFrame.<event_handler>
        if self.__xLims is None:
            self.secAnaTextCtrl.Value='No Selection Region -- doing whole spectrum:'
        photd=self.Parent.spec.getPhotometry(self.__xLims)
        photl=[]
        bandorder=('AB','U','V','B','R','I','J','H','K','L','M')
        for s in bandorder:
            if s in photd:
                photl.append(s+': '+str(photd[s]))
                del photd[s]
        photl.extend([k+': '+str(v) for k,v in photd.iteritems()])
        phots='\n'.join(photl)
        self.secAnaTextCtrl.Value+='\n\n'
        self.secAnaTextCtrl.Value+=phots

    def onKCorr(self, event): # wxGlade: SectionAnalysisFrame.<event_handler>
        if self.__xLims is None:
            self.secAnaTextCtrl.Value='No Selection Region -- doing whole spectrum:'
        kd=self.Parent.spec.kCorrection(bandi=0,editeddata=False)
        kl=[]
        bandorder=('AB','U','V','B','R','I','J','H','K','L','M')
        for s in bandorder:
            if s in kd:
                kl.append(s+': '+str(kd[s]))
                del kd[s]
        kl.extend([k+': '+str(v) for k,v in kd.iteritems()])
        ks='\n'.join(kl)
        self.secAnaTextCtrl.Value+='\n\n'
        self.secAnaTextCtrl.Value+=ks

# end of class SectionAnalysisFrame


class MainFrame(wx.Frame):
    """
    Primary spylot frame - see __init__ for details on calling
    """
    def __init__(self, *args, **kwds):
        """
        This generates the spylot GUI - args and kwargs are passed on to
        wx.Frame, except for:
        initialSpec : either a Spectrum or an iterator over Spectrum's to be 
        loaded as the spectra that are present initiall
        addinmenuitems: a sequence of tuples of the form (menuentryname,callable) 
        or (menuentryname,callable,acceleratorkey) that will appear in the 
        "Addins" menu in Spylot - the callable will be called as func(spectrum)
        """
        #process keywords before wx.Frame constructor tries to digest them
        self.specList = []
        self.specListIndex = 0
        self.spec = None
        if 'initialSpec' in kwds:
            initialSpec = kwds.pop('initialSpec')
            if hasattr(initialSpec,'__iter__') and len(initialSpec)>0:
                self.specList=initialSpec
                initialSpec=self.specList[0]
            if not hasattr(initialSpec,'drawToAxes'):
                raise TypeError("supplied initial spectrum does not seem to be a Spectrum")
            self.spec = initialSpec
        if self.spec is None:
            from spylot import Spectrum #this is only necessary if there is no starting spectrum
            self.spec = Spectrum()
            
        if 'addinmenuitems' in kwds:
            menus = kwds.pop('addinmenuitems')
        else:
            menus = None

        #declare instance variables necessary for wxGlade items to initialize
        self.fig = Figure(figsize=(1.333,1))
        self.axes = self.fig.add_subplot(111)
        self.drawingSettings=self.spec.defaultDrawingSettings()
        self.spec.drawToAxes(self.axes,drawsettings=self.drawingSettings)
        
        # begin wxGlade: MainFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.sizer_5_staticbox = wx.StaticBox(self, -1, "z (redshift)")
        
        # Menu Bar
        self.mainFrame_menubar = wx.MenuBar()
        wxglade_tmp_menu = wx.Menu()
        wxglade_tmp_menu.Append(101, "Load...\tCtrl+L", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(102, "Save...\tCtrl+S", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(103, "Print...\tCtrl+P", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendSeparator()
        wxglade_tmp_menu.Append(111, "Next Spectrum\t.", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(112, "Previous\t,", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(113, "Jump to Spectrum...\tj", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendSeparator()
        wxglade_tmp_menu.Append(141, "Next Band\t]", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(142, "Previous\t[", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(143, "Band Info\tAlt+I", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendSeparator()
        wxglade_tmp_menu.Append(121, "Set Title...", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendSeparator()
        wxglade_tmp_menu.Append(132, "Smooth...\tAlt+S", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(133, "Subtract Continuum...\tAlt+C", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(131, "Reset Spectrum\tAlt+R", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(136, "Save Edits\tCtrl+Alt+S", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(134, "Restore Saved Edits\tCtrl+Alt+R", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(135, "Remove Outliers...\tAlt+O", "", wx.ITEM_NORMAL)
        self.mainFrame_menubar.Append(wxglade_tmp_menu, "Spectrum")
        wxglade_tmp_menu = wx.Menu()
        wxglade_tmp_menu.Append(201, "Line Lists...", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(203, "Line Appearence...", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(202, "Reset Figure", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendSeparator()
        wxglade_tmp_menu.Append(211, "Rescale Limits per Spectrum", "", wx.ITEM_CHECK)
        wxglade_tmp_menu.Append(213, "Rescale Y Limits per Band", "", wx.ITEM_CHECK)
        wxglade_tmp_menu.Append(212, "Rescale Limits\tAlt+L", "", wx.ITEM_NORMAL)
        self.mainFrame_menubar.Append(wxglade_tmp_menu, "Settings")
        wxglade_tmp_menu = wx.Menu()
        wxglade_tmp_menu.Append(301, "None\tn", "", wx.ITEM_RADIO)
        wxglade_tmp_menu.Append(302, "Section Analysis\ts", "", wx.ITEM_RADIO)
        wxglade_tmp_menu.Append(303, "Line Analysis\tl", "", wx.ITEM_RADIO)
        wxglade_tmp_menu.Append(304, "Photometry Analysis\tp", "", wx.ITEM_RADIO)
        wxglade_tmp_menu.AppendSeparator()
        wxglade_tmp_menu.Append(311, "Zoom\tz", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(312, "Pan\tp", "", wx.ITEM_NORMAL)
        self.mainFrame_menubar.Append(wxglade_tmp_menu, "Analysis Mode")
        wxglade_tmp_menu = wx.Menu()
        wxglade_tmp_menu.Append(402, "Keyboard Shortcuts...", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(401, "About...", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendSeparator()
        wxglade_tmp_menu.Append(411, "Extra Spectrum Data...", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendSeparator()
        wxglade_tmp_menu.Append(421, "Garbage Collect", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(422, "Print top objects", "", wx.ITEM_NORMAL)
        self.mainFrame_menubar.Append(wxglade_tmp_menu, "Help")
        self.SetMenuBar(self.mainFrame_menubar)
        # Menu Bar end
        self.mainFrame_statusbar = self.CreateStatusBar(2, 0)
        self.spectrumCanvas = FigureCanvas(self, -1, self.fig)
        self.figureNavToolbar = NavBar(self.spectrumCanvas)
        self.showLinesCheckBox = wx.CheckBox(self, -1, "Show Lines?")
        self.overplotCheckBox = wx.CheckBox(self, -1, "Show Overplot? Band:")
        self.overplotBandTextCtrl = wx.TextCtrl(self, -1, "", style=wx.TE_PROCESS_ENTER)
        self.markZeroCheckBox = wx.CheckBox(self, -1, "Mark 0-point?")
        self.xScaleComboBox = wx.ComboBox(self, -1, choices=["flux/Angstrom", "flux/Hz", "Pixels"], style=wx.CB_DROPDOWN|wx.CB_READONLY)
        self.lowerZLabel = wx.StaticText(self, -1, "00.000")
        self.upperZLabel = wx.StaticText(self, -1, "01.000", style=wx.ALIGN_RIGHT)
        self.zSlider = wx.Slider(self, -1, 0, 0, 250)
        self.finerButton = wx.Button(self, -1, "Finer")
        self.coarserButton = wx.Button(self, -1, "Coarser")
        self.zTextCtrl = wx.TextCtrl(self, -1, "", style=wx.TE_PROCESS_ENTER)

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_MENU, self.onSpecLoad, id=101)
        self.Bind(wx.EVT_MENU, self.onSpecSave, id=102)
        self.Bind(wx.EVT_MENU, self.onSpecPrint, id=103)
        self.Bind(wx.EVT_MENU, self.onSpecNext, id=111)
        self.Bind(wx.EVT_MENU, self.onSpecPrev, id=112)
        self.Bind(wx.EVT_MENU, self.onSpecJump, id=113)
        self.Bind(wx.EVT_MENU, self.onBandNext, id=141)
        self.Bind(wx.EVT_MENU, self.onBandPrev, id=142)
        self.Bind(wx.EVT_MENU, self.onBandInfo, id=143)
        self.Bind(wx.EVT_MENU, self.onSpecTitle, id=121)
        self.Bind(wx.EVT_MENU, self.onSpecSmooth, id=132)
        self.Bind(wx.EVT_MENU, self.onContSub, id=133)
        self.Bind(wx.EVT_MENU, self.onSpecReset, id=131)
        self.Bind(wx.EVT_MENU, self.onSpecSaveEdits, id=136)
        self.Bind(wx.EVT_MENU, self.onSpecRestoreSaved, id=134)
        self.Bind(wx.EVT_MENU, self.onRemoveOutliers, id=135)
        self.Bind(wx.EVT_MENU, self.onSetLineLists, id=201)
        self.Bind(wx.EVT_MENU, self.onSetLineAppearence, id=203)
        self.Bind(wx.EVT_MENU, self.onSetReset, id=202)
        self.Bind(wx.EVT_MENU, self.onPerSpec, id=211)
        self.Bind(wx.EVT_MENU, self.onReScale, id=212)
        self.Bind(wx.EVT_MENU, self.onSelectNone, id=301)
        self.Bind(wx.EVT_MENU, self.onSelectSec, id=302)
        self.Bind(wx.EVT_MENU, self.onSelectLine, id=303)
        self.Bind(wx.EVT_MENU, self.onSelectPhoto, id=304)
        self.Bind(wx.EVT_MENU, self.onZoom, id=311)
        self.Bind(wx.EVT_MENU, self.onPan, id=312)
        self.Bind(wx.EVT_MENU, self.onKeyShort, id=402)
        self.Bind(wx.EVT_MENU, self.onAbout, id=401)
        self.Bind(wx.EVT_MENU, self.onExtraSpec, id=411)
        self.Bind(wx.EVT_MENU, self.onGC, id=421)
        self.Bind(wx.EVT_MENU, self.onPrintTop, id=422)
        self.Bind(wx.EVT_CHECKBOX, self.onShowLines, self.showLinesCheckBox)
        self.Bind(wx.EVT_CHECKBOX, self.onShowOverplot, self.overplotCheckBox)
        self.Bind(wx.EVT_TEXT_ENTER, self.onOverplotBand, self.overplotBandTextCtrl)
        self.Bind(wx.EVT_CHECKBOX, self.onMarkZero, self.markZeroCheckBox)
        self.Bind(wx.EVT_COMBOBOX, self.onXScale, self.xScaleComboBox)
        self.Bind(wx.EVT_COMMAND_SCROLL_ENDSCROLL, self.zSetSlide, self.zSlider)
        self.Bind(wx.EVT_COMMAND_SCROLL_THUMBTRACK, self.zSetSlide, self.zSlider)
        self.Bind(wx.EVT_BUTTON, self.zSliderAdjust, self.finerButton)
        self.Bind(wx.EVT_BUTTON, self.zSliderAdjust, self.coarserButton)
        self.Bind(wx.EVT_TEXT_ENTER, self.zSetText, self.zTextCtrl)
        # end wxGlade
        
            
        #non wxGlade event bindings:
        self.zTextCtrl.Bind(wx.EVT_KILL_FOCUS, self.zSetText, self.zTextCtrl)
        WheelZoomer(self.spectrumCanvas)
        
        #initial settings for most instance variable
        self.sectionAnalysisToolbar = SectionAnalysisFrame(self,-1,"")
        self.lineAnalysisToolbar = LineAnalysisFrame(self,-1,"")
        self.photoAnalysisToolbar = PhotometryFrame(self,-1,"")
        self.contSubDialog = FitDialog([1,2],[3,4],('spline','poly','bb'),self,-1) #fake data -real data is loaded onContSub
        
        self.__sliderLowerZ=0.0
        if self.spec.z == 0:
            self.__sliderUpperZ=1.0
        else:
            self.__sliderUpperZ= 2.0*self.spec.z
        self._activeTBar=None
        self._numtomatch = 5
        
        self.mainFrame_menubar.FindItemById(211).Check(True)
        self.mainFrame_menubar.FindItemById(213).Check(True)
        
        self.updateStatusBar()
        self.updateBandMenu()
        
        #generate and apply accelerators for miniframe toolbars
        accels=[]
        for menu,label in self.mainFrame_menubar.GetMenus():
            for mi in menu.GetMenuItems():
                ac=mi.GetAccel()
                if ac is not None:
                    accels.append((ac.GetFlags(),ac.GetKeyCode(),mi.GetId()))
                        
        selectTable=wx.AcceleratorTable(accels)
        self.lineAnalysisToolbar.SetAcceleratorTable(selectTable)
        self.sectionAnalysisToolbar.SetAcceleratorTable(selectTable)
        self.photoAnalysisToolbar.SetAcceleratorTable(selectTable)

        #disable previous spec menu item, and only enable next spec item if there are 2+ items in specList
        self.mainFrame_menubar.FindItemById(112).Enable(False)
        if len(self.specList) < 2:
            self.mainFrame_menubar.FindItemById(111).Enable(False)

        #do final updates for things that have possible changes to their default values
        self.updateSliderBounds()
        self.showLinesCheckBox.SetValue(self.drawingSettings.drawMarks)
        self.zTextCtrl.SetValue(str(self.spec.z))
        self.resetLims()
        self.overplotCheckBox.SetValue(self.drawingSettings.drawOverplot)
        self.overplotBandTextCtrl.SetValue(str(self.drawingSettings.overplotBand))
        
        #TODO:do a better solution than this highest hack
        if menus is not None:
            self.addinshandlers={}
            addinsWxMenu = wx.Menu()
            id=wx.ID_HIGHEST
            for t in menus:
                menustr=t[0]
                if len(t)==3:
                    menustr+='\t'+t[2]
                id+=1
                lastmitem=addinsWxMenu.Append(id, menustr, "", wx.ITEM_NORMAL)
                lastid=lastmitem.GetId()
                #print 'DEBUG INFO:',menustr,'id='+str(lastid),'already there?',self.mainFrame_menubar.FindItemById(lastid)
                self.Bind(wx.EVT_MENU, self.onAddinsMenu, id=lastid)
                self.addinshandlers[lastid]=t[1]
            self.mainFrame_menubar.Append(addinsWxMenu, "Add-ins")

    def __set_properties(self):
        # begin wxGlade: MainFrame.__set_properties
        self.SetTitle("Spylot")
        self.SetSize((800, 647))
        self.mainFrame_statusbar.SetStatusWidths([-1, -1])
        # statusbar fields
        mainFrame_statusbar_fields = ["Spec", "Band"]
        for i in range(len(mainFrame_statusbar_fields)):
            self.mainFrame_statusbar.SetStatusText(mainFrame_statusbar_fields[i], i)
        self.xScaleComboBox.SetSelection(0)
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MainFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_5 = wx.StaticBoxSizer(self.sizer_5_staticbox, wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_25 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_24 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.spectrumCanvas, 1, wx.EXPAND, 0)
        sizer_1.Add(self.figureNavToolbar, 0, wx.EXPAND, 0)
        sizer_9.Add(self.showLinesCheckBox, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_24.Add(self.overplotCheckBox, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_24.Add(self.overplotBandTextCtrl, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_9.Add(sizer_24, 1, wx.EXPAND, 0)
        sizer_9.Add(self.markZeroCheckBox, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_9.Add(self.xScaleComboBox, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_2.Add(sizer_9, 1, wx.EXPAND, 0)
        sizer_25.Add(self.lowerZLabel, 0, wx.ALIGN_BOTTOM, 0)
        sizer_25.Add((20, 1), 1, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_25.Add(self.upperZLabel, 0, wx.ALIGN_BOTTOM, 0)
        sizer_3.Add(sizer_25, 1, wx.EXPAND, 0)
        sizer_3.Add(self.zSlider, 0, wx.EXPAND, 0)
        sizer_4.Add(self.finerButton, 0, 0, 0)
        sizer_4.Add((10, 0), 0, 0, 0)
        sizer_4.Add(self.coarserButton, 0, 0, 0)
        sizer_3.Add(sizer_4, 1, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_2.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_5.Add(self.zTextCtrl, 0, 0, 0)
        sizer_2.Add(sizer_5, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_2, 0, wx.TOP|wx.BOTTOM|wx.EXPAND, 8)
        self.SetSizer(sizer_1)
        self.Layout()
        # end wxGlade
        
    def updateFigure(self):
        self.spec.drawToAxes(self.axes,clear=True,drawsettings=self.drawingSettings)
        self.spectrumCanvas.draw()
        if self._activeTBar is not None:
            self._activeTBar.update(self.axes)

    def updateZ(self):
        self.updateSliderBounds()
        self.zTextCtrl.SetValue(str(self.spec.z))
        self.updateFigure()

    def updateSliderBounds(self,newrange=None):
        """
        this will update the slider bounds and slider value for a different range in z-values
        if newrange is undefined (or None), only the labels will be updated - the actual limits
        will be unchanged
        if newrange is negative, it will be taken to mean a factor to multiply the current range by
        """

        oldrange=self.__sliderUpperZ-self.__sliderLowerZ
        if newrange != None:
            if newrange<0:
                newrange *= -1*oldrange

            zval=self.spec.z

            if zval-newrange/2. <0:
                self.__sliderLowerZ=0
                self.__sliderUpperZ=newrange
                self.zSlider.SetValue(int(self.zSlider.GetMax()*zval/newrange))
            else:
                self.__sliderLowerZ=zval-newrange/2.
                self.__sliderUpperZ=zval+newrange/2.
                self.zSlider.SetValue(int(self.zSlider.GetMax()/2))
        else:
            self.zSlider.SetValue(int(self.zSlider.GetMax()*self.spec.z/oldrange))

        self.lowerZLabel.SetLabel('%1.3f' % self.__sliderLowerZ)
        self.upperZLabel.SetLabel('%1.3f' % self.__sliderUpperZ)

    def newSpectrum(self,newspec):
        self.spec=newspec
        self.zTextCtrl.SetValue(str(self.spec.z))
        self.updateSliderBounds()
        self.drawingSettings.drawMarks = self.showLinesCheckBox.GetValue()
        self.updateStatusBar()
        self.updateBandMenu()
        if self.GetMenuBar().FindItemById(211).IsChecked():
            self.resetLims()
            
        
    def updateStatusBar(self):
        spec=self.spec
        si=self.specListIndex
        nos=len(self.specList)
        if nos ==0:
            nos=1
        self.mainFrame_statusbar.SetStatusText('Spectrum '+str(si+1)+' of '+
        str(nos),0)
        nob=spec.getNumberOfBands()
        currband=spec.getCurrentBandId()
        self.mainFrame_statusbar.SetStatusText('Band '+str(currband+1)+' of '+
        str(nob),1)
        
    def updateBandMenu(self):
        advancable=self.spec.isBandAdvancable()
        
        mb = self.GetMenuBar()
        nextItem = mb.FindItemById(141)
        prevItem = mb.FindItemById(142)
        
        nextItem.Enable(advancable[0])
        prevItem.Enable(advancable[1])
        
    def resetLims(self):
        if self.GetMenuBar().FindItemById(211).IsChecked():
            xl,xu,yl,yu=self.spec.getCurrentLimits(fnu=self.drawingSettings.fnu)
            self.axes.set_xlim(xl,xu)
            self.axes.set_ylim(yl,yu)
        else:
            clims=[s.getCurrentLimits(0,fnu=self.drawingSettings.fnu) for s in self.specList] if self.specList else [self.spec.getCurrentLimits(0,fnu=self.drawingSettings.fnu)]
            self.axes.set_xlim(min((l[0] for l in clims)),max((l[1] for l in clims)))
            self.axes.set_ylim(min((l[2] for l in clims)),max((l[3] for l in clims)))
        
    def zSliderAdjust(self, event): # wxGlade: MainFrame.<event_handler>
        if event.GetId()==self.coarserButton.GetId():
            #self.updateSliderBounds((self.__sliderUpperZ-self.__sliderLowerZ)*2)
            self.updateSliderBounds(-4)
        elif event.GetId()==self.finerButton.GetId():
            self.updateSliderBounds(-0.25)
            #self.updateSliderBounds((self.__sliderUpperZ-self.__sliderLowerZ)/2)
        else:
            raise Exception("impossible window ID is trying to adjust slider Granularity")


    def zSetSlide(self, event): # wxGlade: MainFrame.<event_handler>
        zrange=self.__sliderUpperZ-self.__sliderLowerZ
        self.spec.z=self.__sliderLowerZ+zrange*self.zSlider.GetValue()/self.zSlider.GetMax()
        self.zTextCtrl.SetValue(str(self.spec.z))
        self.updateFigure()

    def zSetText(self, event): # wxGlade: MainFrame.<event_handler>
        zval=float(self.zTextCtrl.GetValue())
        if zval != self.spec.z:
            self.spec.z=zval
            self.zTextCtrl.SetValue(str(zval))
            self.updateFigure()

            self.updateSliderBounds(self.__sliderUpperZ-self.__sliderLowerZ)

    def onShowLines(self, event): # wxGlade: MainFrame.<event_handler>
        self.drawingSettings.drawMarks = self.showLinesCheckBox.Value
        self.updateFigure()

    def onAbout(self,event):# wxGlade: MainFrame.<event_handler>
        info = wx.AboutDialogInfo()
        info.Name = "Spylot"
        info.Version = "Pre-Release"
        info.Copyright = "(C) 2007 Erik Tollerud"
        info.Description ="""
        Spectrum pLOTter
                        ^(PYthon)
        """
        info.WebSite = ("http://ags.uci.edu/~etolleru", "Erik Tollerud's web page")
        info.Developers = [ "Erik Tollerud" ]


        # Then we call wx.AboutBox giving it that info object
        wx.AboutBox(info)

    def onSpecLoad(self, event): # wxGlade: MainFrame.<event_handler>
        from os import getcwd
        from os.path import basename
        filters = "FITS file (*.fits)|*.fits|"             \
           "All files (*.*)|*.*"

        dlg = wx.FileDialog(
            self, message="Choose a spectrum file",
            defaultDir=getcwd(),
            defaultFile="",
            wildcard=filters,
            style=wx.OPEN | wx.CHANGE_DIR
            )

        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
            self.newSpectrum(Spectrum.loadFromFitsFile(path))
            self.spec.name = basename(self.spec.name).replace('.fits','')
            self.updateFigure()

    def onSpecSave(self, event): # wxGlade: MainFrame.<event_handler>
        from os import getcwd

        filters = "FITS file (*.fits)|*.fits|"             \
           "All files (*.*)|*.*"

        dlg = wx.FileDialog(self, message="Save file as ...", defaultDir=getcwd(),
            defaultFile="", wildcard=filters, style=wx.SAVE)

        dlg.SetFilterIndex(0)

        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
            print 'saving FITS file to',path
            Spectrum.saveToFitsFile(path,self.spec)
        dlg.Destroy()

    def onSpecPrint(self, event): # wxGlade: MainFrame.<event_handler>
        print "Event handler `onSpecPrint' not fully implemented"
        data = wx.PrintDialogData()

        data.EnableSelection(True)
        data.EnablePrintToFile(True)
        data.EnablePageNumbers(True)
        data.SetMinPage(1)
        data.SetMaxPage(5)
        data.SetAllPages(True)

        dlg = wx.PrintDialog(self, data)

        if dlg.ShowModal() == wx.ID_OK:
            data = dlg.GetPrintDialogData()
            self.log.WriteText('GetAllPages: %d\n' % data.GetAllPages())
            
        print data

        dlg.Destroy()

    def onSpecTitle(self, event): # wxGlade: MainFrame.<event_handler>
        dlg = wx.TextEntryDialog(self, 'Spectrum Title?','Title?',self.spec.name)
        if dlg.ShowModal() == wx.ID_OK:
            self.spec.name=dlg.GetValue()

        dlg.Destroy()
        self.updateFigure()

    def onSpecReset(self, event): # wxGlade: MainFrame.<event_handler>
        self.spec.reset(False)
        self.updateFigure()
        
    def onSpecSaveEdits(self, event): # wxGlade: MainFrame.<event_handler>
        self.spec.saveEdits()
        
    def onSpecRestoreSaved(self, event): # wxGlade: MainFrame.<event_handler>
        self.spec.reset(True)
        self.updateFigure()


    def onSpecSmooth(self, event): # wxGlade: MainFrame.<event_handler>
        #dlg = wx.TextEntryDialog(self, 'Smoothing Kernel?(negative values make a gaussian kernel, positive are box)','Smooth','3')
        dlg = wx.TextEntryDialog(self, 'Smoothing Kernel?\n(negative values make a gaussian kernel, positive use box)','Smooth','3')
        if dlg.ShowModal() == wx.ID_OK:
            try:
                self.spec.smooth(float(dlg.GetValue()))
            except ValueError:
                dlg2=wx.MessageDialog(self,"Could not interpret input value "+dlg.GetValue()+", not smoothing","Invalid Input",wx.OK|wx.ICON_WARNING)
                dlg2.ShowModal()
                dlg2.Destroy()

        dlg.Destroy()
        self.updateFigure()

    def onSetLineLists(self, event): # wxGlade: MainFrame.<event_handler>
        #dlg=LineListDialog(self.spec.__class__,self,-1)
        dlg=LineListDialog(self.spec,self,-1)
        dlg.ShowModal()
        dlg.Destroy()

        dlg=wx.TextEntryDialog(self,'Number of Lines To Look for?','',str(self._numtomatch))
        try:
            if dlg.ShowModal() == wx.ID_OK:
                self._numtomatch=int(dlg.Value)
        except ValueError:
            dlg2=wx.MessageDialog(self,'Line Number input was not an integer','',wx.ID_OK|wx.ICON_ERROR)
            dlg2.ShowModal()
            dlg2.Destroy()
        finally:
            dlg.Destroy()

        self.updateFigure()

    def onSpecNext(self, event): # wxGlade: MainFrame.<event_handler>
        if self.specListIndex<len(self.specList)-1:
            #if self._activeTBar is not None:
            #    self._activeTBar.cleanup()

            self.specListIndex+=1
            self.newSpectrum(self.specList[self.specListIndex])
            self.updateFigure()

            mb = self.GetMenuBar()
            nextItem = mb.FindItemById(111)
            prevItem = mb.FindItemById(112)

            if self.specListIndex >= len(self.specList)-1:
                nextItem.Enable(False)
            if not prevItem.IsEnabled():
                prevItem.Enable(True)

            if self._activeTBar is not None:
                self._activeTBar.update(self.axes)



    def onSpecPrev(self, event): # wxGlade: MainFrame.<event_handler>
        if self.specListIndex>0:
            self.specListIndex-=1
            self.newSpectrum(self.specList[self.specListIndex])
            self.updateFigure()

            mb = self.GetMenuBar()
            nextItem = mb.FindItemById(111)
            prevItem = mb.FindItemById(112)

            if self.specListIndex <= 0:
                prevItem.Enable(False)
            if not nextItem.IsEnabled():
                nextItem.Enable(True)

            if self._activeTBar is not None:
                self._activeTBar.update(self.axes)
                
    def onSpecJump(self, event): # wxGlade: MainFrame.<event_handler>
        dlg=wx.TextEntryDialog(self,'Spectrum number?','Jump to Spectrum',str(self.specListIndex+1))
        
        if dlg.ShowModal() == wx.ID_OK:
            try:
                i=int(dlg.GetValue())-1
                if not 0 <= i <= len(self.specList)-1:
                    raise IndexError('index '+dlg.GetValue()+' is not a valid spectrum index')
                self.specListIndex=i
                self.newSpectrum(self.specList[self.specListIndex])
                self.updateFigure()

                mb = self.GetMenuBar()
                nextItem = mb.FindItemById(111)
                prevItem = mb.FindItemById(112)

                if self.specListIndex <= 0:
                    prevItem.Enable(False)
                if not nextItem.IsEnabled():
                    nextItem.Enable(True)

                if self._activeTBar is not None:
                    self._activeTBar.update(self.axes)
            except Exception,e:
                dlg2=wx.MessageDialog(self,'Problem with index input:\n'+str(e),"Couldn't Jump",wx.ICON_ERROR)
                dlg2.ShowModal()
                dlg2.Destroy()
        dlg.Destroy()

    def onSelectNone(self, event): # wxGlade: MainFrame.<event_handler>
        if self._activeTBar is not None:
            self._activeTBar.Show(False)
            self._activeTBar=None
            self.updateFigure()
            #necessary for miniframe accelerators
            mi=self.mainFrame_menubar.FindItemById(301)
            mi.Check(True)
        

    def onSelectSec(self, event): # wxGlade: MainFrame.<event_handler>
        if self._activeTBar is not None:
            self._activeTBar.Show(False)
        self._activeTBar=self.sectionAnalysisToolbar
        self._activeTBar.Show(True)
        #necessary for miniframe accelerators
        mi=self.mainFrame_menubar.FindItemById(302)
        mi.Check(True)
        

    def onSelectLine(self, event): # wxGlade: MainFrame.<event_handler>
        if self._activeTBar is not None:
            self._activeTBar.Show(False)
        self._activeTBar=self.lineAnalysisToolbar
        self._activeTBar.Show(True)
        #necessary for miniframe accelerators
        mi=self.mainFrame_menubar.FindItemById(303)
        mi.Check(True)
    
    def onSelectPhoto(self, event): # wxGlade: MainFrame.<event_handler>
        if self._activeTBar is not None:
            self._activeTBar.Show(False)
        self._activeTBar=self.photoAnalysisToolbar
        self._activeTBar.Show(True)
        #necessary for miniframe accelerators
        mi=self.mainFrame_menubar.FindItemById(304)
        mi.Check(True)

    def onSetReset(self, event): # wxGlade: MainFrame.<event_handler>
        #self.fig = Figure()
        xlims=self.axes.get_xlim()
        ylims=self.axes.get_ylim()
        self.fig.clear()
        self.axes = self.fig.add_subplot(111)
        self.axes.set_xlim(xlims)
        self.axes.set_ylim(ylims)
        self.updateFigure()

    def onMarkZero(self, event): # wxGlade: MainFrame.<event_handler>
        self.drawingSettings.markZero=(0,0,0) if self.markZeroCheckBox.Value else False
        self.updateFigure()
        
    def onContSub(self, event): # wxGlade: MainFrame.<event_handler>
        self.contSubDialog.setData(self.spec.getCurrentXAxis(),self.spec.getCurrentData(0))
        if self.contSubDialog.ShowModal() == wx.ID_OK:
            self.spec.subtractContinuum(self.contSubDialog.getFit(),conterr=self.contSubDialog.getFitRMSDev())
        self.updateFigure()

    def onSetLineAppearence(self, event): # wxGlade: MainFrame.<event_handler>
        dlg=LineAppearDialog(self,-1)
        if dlg.ShowModal() == wx.ID_OK:#internally applies the Spectrum settings
            self.updateFigure()
        dlg.Destroy()
        
    def onAddinsMenu(self, event):
        id=event.GetId()
        tocall=self.addinshandlers[id]
        tocall(self.spec)

    def onZoom(self, event): # wxGlade: MainFrame.<event_handler>
        self.figureNavToolbar.clickZoom()

    def onPan(self, event): # wxGlade: MainFrame.<event_handler>
         self.figureNavToolbar.clickPan()
        
    def onBandNext(self, event): # wxGlade: MainFrame.<event_handler>
        self.spec.nextBand()
        if self.mainFrame_menubar.FindItemById(213).IsChecked():
            xl,xu,yl,yu=self.spec.getCurrentLimits(fnu=self.drawingSettings.fnu)
            self.axes.set_ylim(yl,yu)
        self.updateFigure()
        self.updateStatusBar()
        self.updateBandMenu()
        
    def onBandPrev(self, event): # wxGlade: MainFrame.<event_handler>
        self.spec.prevBand()
        if self.mainFrame_menubar.FindItemById(213).IsChecked():
            xl,xu,yl,yu=self.spec.getCurrentLimits(fnu=self.drawingSettings.fnu)
            self.axes.set_ylim(yl,yu)
        self.updateFigure()
        self.updateStatusBar()
        self.updateBandMenu()

    def onBandInfo(self, event): # wxGlade: MainFrame.<event_handler>
        spec=self.spec
        bi=spec.getCurrentBandId()
        binfo=spec.getBandInfo(bi)
        if binfo is None:
            binfo = 'No Information for this Band'
        bistr='Band #'+str(bi)+' of '+str(spec.getNumberOfBands())+'\n'+binfo
        dlg=wx.MessageDialog(self,bistr,'Band Information',wx.ID_OK|wx.ICON_INFORMATION)
        dlg.ShowModal()
        dlg.Destroy()
        
    def onPerSpec(self, event): # wxGlade: MainFrame.<event_handler>
        chk = event.Checked()
        if not event.Checked():
            self.resetLims()
        if not chk:
            self.mainFrame_menubar.FindItemById(213).Check(False)
        self.mainFrame_menubar.FindItemById(213).Enable(chk)

    def onReScale(self, event): # wxGlade: MainFrame.<event_handler>
        xl,xu,yl,yu=self.spec.getCurrentLimits(fnu=self.drawingSettings.fnu)
        self.axes.set_xlim(xl,xu)
        self.axes.set_ylim(yl,yu)
        self.updateFigure()

    def onRemoveOutliers(self, event): # wxGlade: MainFrame.<event_handler>
        dlg=wx.TextEntryDialog(self,'Sigma to filter?','Remove Outliers','3')
        try:
            if dlg.ShowModal() == wx.ID_OK:
                self.spec.removeOutliers(sigma=float(dlg.Value))
                self.updateFigure()
        finally:
            dlg.Destroy()


    def onGC(self, event): # wxGlade: MainFrame.<event_handler>
        from gc import collect
        print 'Collected',collect(),'Objects'

    def onPrintTop(self, event): # wxGlade: MainFrame.<event_handler>
        from erikutils import get_gc_object_counts
        print get_gc_object_counts(25,True)

    def onXScale(self, event): # wxGlade: MainFrame.<event_handler>
        sel = self.xScaleComboBox.Selection
        spec=self.spec
        
        if sel == 0: #flambda
            self.drawingSettings.pixelscale = False
            self.drawingSettings.fnu = False
        elif sel == 1: #fnu
            self.drawingSettings.pixelscale = False
            self.drawingSettings.fnu = True
        elif sel == 2: #pixel scale
            self.drawingSettings.pixelscale = True
        else:
            raise NotImplementedError('no action for xscale selection index '+str(sel)) 
        xl,xu,yl,yu=spec.getCurrentLimits(fnu=self.drawingSettings.fnu,pixelscale=self.drawingSettings.pixelscale)
        self.axes.set_xlim(xl,xu)
        self.axes.set_ylim(yl,yu)
        self.updateFigure()

    def onShowOverplot(self, event): # wxGlade: MainFrame.<event_handler>
        self.drawingSettings.drawOverplot = self.overplotCheckBox.Value
        self.updateFigure()

    def onOverplotBand(self, event): # wxGlade: MainFrame.<event_handler>
        try:
            val = int(self.overplotBandTextCtrl.Value)
            #if val < 0:
            #    raise Exception
            self.drawingSettings.overplotBand = val
        except:
            self.overplotBandTextCtrl.SetValue(str(self.drawingSettings.overplotBand))
        self.updateFigure()

    def onKeyShort(self, event): # wxGlade: MainFrame.<event_handler>
        print "Event handler `onKeyShort' not implemented"
        event.Skip()

    def onExtraSpec(self, event): # wxGlade: MainFrame.<event_handler>
        from wx.lib.dialogs import ScrolledMessageDialog
        attrdict=self.spec.getExtraAttribs(True)
        vals=[]
        for k,v in attrdict.iteritems():
            vals.append(str(k)+': '+str(v))
        s='\n'.join(vals)
        dlg = ScrolledMessageDialog(self, s, "Extra Spectrum Information")
        dlg.ShowModal()
        dlg.Destroy()

# end of class MainFrame


class SpylotApp(wx.App):
    """
    Generates a wx.App for spylot - any arguments other than keyword arguments
    mentioned below will be passed to wx.__init__ constructor
    
    initialSpec is the inital Spectrum (or sequence of Spectrum objects)
    initialMarkLines determines if lines should start out marked
    outputFile is a file to save spectrum and line data into
    extramenus is a sequence of sequences - each element is a 2-or-3-element
    sequence of the form (menuitem,eventhandlefunc,[shortcut]) - the handlers
    should have signature func(spectrum)
    """
    def __init__(self,*args,**kwargs):
        if 'initialSpec' in kwargs:
            self.ispec=kwargs.pop('initialSpec')
        else:
            self.ispec=None

        if 'initialMarkLines' in kwargs:
            self.imark=kwargs.pop('initialMarkLines')
        else:
            self.imark=False

        if 'outputFile' in kwargs:
            self.opfn=kwargs.pop('outputFile')
        else:
            self.opfn=None
        
        if 'addinmenuitems' in kwargs:
            self.addinmenuitems=kwargs.pop('addinmenuitems')
        else:
            self.opfn=None
        
        #TODO:Put this in when there isn't so much debugging to do
        #if 'redirect' not in kwargs:
        #    kwargs['redirect']=True

        wx.App.__init__(self,*args,**kwargs)


    def OnInit(self):
        wx.InitAllImageHandlers()
        mainFrame = MainFrame(None, -1, "",initialSpec=self.ispec,addinmenuitems=self.addinmenuitems)
        mainFrame.showLinesCheckBox.SetValue(self.imark)
        mainFrame.onShowLines(None)
        self.SetTopWindow(mainFrame)

        #for saving in OnExit
        self.slist=mainFrame.specList
        if len(self.slist)==0:
            self.slist=[mainFrame.spec]

        mainFrame.Show()
        return 1

    def OnExit(self):
        #Possible problems with class instances! if some spectra are from
        #different versions of Spectrum, weird things may result
        if self.opfn!=None:
            self.spec.outputSpectrumData(self.opfn,self.slist)

# end of class SpylotApp

if __name__ == "__main__":
    app = SpylotApp(0)
    app.MainLoop()
    #app = wx.PySimpleApp(0)
    #wx.InitAllImageHandlers()
    #frame_1 = MainFrame(None, -1, "")
    #app.SetTopWindow(frame_1)
    #frame_1.Show()
    #app.MainLoop()
